#!/bin/bash

# Copyright (c) xFusion Digital Technologies Co., Ltd. 2022. All rights reserved.
# Description: link state test
# Author: xFusion Digital Technologies
# Create: 2022-1-17

os_load_base="/OSM/script/os_load_base.sh"
if [ -f "$os_load_base" ];then
    source /OSM/script/os_load_base.sh
fi

alias OS_echo=echo

fn_test_gateway()
{
    local l_gateway=$1
    local l_iface=$2
    if [ -z "${l_gateway}" ] || [ -z "${l_iface}" ]; then
        OS_echo "[link_state_test.sh] Param error, gateway or iface in default route is null."
        return 1
    fi
    
    ping -I ${l_iface} -c 1 -w 1 ${l_gateway} >/dev/null 2>&1
    if [ $? -ne 0 ]; then
        arping -I ${l_iface} -c 1 ${l_gateway} >/dev/null 2>&1
        if [ $? -eq 0 ]; then
            OS_echo "Gateway[${l_gateway}] is unreachable via ping but is reachable via arping."
        else
            OS_echo "Warning, gateway[${l_gateway}] is unreachable."
        fi
    fi
}

count=$(/sbin/route -n | awk  '{print $1}' | grep -w "0.0.0.0" | wc -l)
if [ "${count}" -eq 0 ]; then
    OS_echo "[link_state_test.sh] There is no default route."
    exit 0
elif [ "${count}" -gt 1 ]; then
    OS_echo "Warning, there is more than one default route."
    /sbin/route -n >/dev/kmsg
fi

/sbin/route -n | awk '$1 == "0.0.0.0" {print $2 "\t" $8}' | while read line
do
    gateway=$(echo "${line}" | awk '{print $1}')
    iface=$(echo "${line}" | awk '{print $2}')
    fn_test_gateway "${gateway}" "${iface}"
done


